
const St = imports.gi.St;
const Main = imports.ui.main;
const Tweener = imports.ui.tweener;
const Gio = imports.gi.Gio;

const Me = imports.misc.extensionUtils.getCurrentExtension();
const Convenience = Me.imports.convenience;
const Gettext = imports.gettext.domain("kiran-show-keyboard");
const _ = Gettext.gettext;

const A11Y_APPLICATIONS_SCHEMA = 'org.gnome.desktop.a11y.applications';
const SHOW_KEYBOARD = 'screen-keyboard-enabled';

let _a11yApplicationsSettings;
let _showKeyboardButton;
let keyboardIcon;

function _showKeyboard() {
    Main.layoutManager.showKeyboard();
}

function init() {
    Convenience.initTranslations("kiran-show-keyboard");
    _a11yApplicationsSettings = new Gio.Settings({ schema_id: A11Y_APPLICATIONS_SCHEMA });
}

function enable() {
    _a11yApplicationsSettings.set_boolean(SHOW_KEYBOARD, true);

    _showKeyboardButton = new St.Bin({ style_class: 'panel-button',
                          reactive: true,
                          can_focus: true,
                          x_fill: true,
                          y_fill: false,
                          track_hover: true });

    keyboardIcon = new St.Icon({ icon_name: 'input-keyboard-symbolic',
                             style_class: 'system-status-icon' });

    _showKeyboardButton.set_style('margin: 0 4px;');
    _showKeyboardButton.set_child(keyboardIcon);
    _showKeyboardButton.connect('button-press-event', _showKeyboard);

    Main.panel._rightBox.insert_child_at_index(_showKeyboardButton, 0);
}

function disable() {
    _a11yApplicationsSettings.set_boolean(SHOW_KEYBOARD, false);

    Main.panel._rightBox.remove_child(_showKeyboardButton);

    _showKeyboardButton.destroy();
    _showKeyboardButton = null;

    keyboardIcon.destroy();
    keyboardIcon = null;
}
